// UserAdmin.cpp
//
// Changed from NetAdmin.cpp to UserAdmin.cpp
// Original by:
// Fixed up 30-Jan-96 michael@ecel.uwa.edu.au
// Fixed up again 96.10.19 rothd@roth.net
// Additions on 6.5.97 tritchey@vne.com
//
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <lmcons.h>     // LAN Manager common definitions
#include <lmerr.h>      // LAN Manager network error definitions
#include <lmUseFlg.h>
#include <lmAccess.h>
#include <lmAPIBuf.h>
#include <lmshare.h>
#undef LPTSTR
#define LPTSTR LPWSTR
#include <lmServer.h>
#undef LPTSTR
#define LPTSTR LPSTR
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <stdio.h>

#define RETURNRESULT(x)		if((x)){ XST_mYES(0); }\
                     		else { XST_mNO(0); }\
                     		XSRETURN(1)
#define SETIV(index,value) sv_setiv(ST(index), value)
#define SETPV(index,string) sv_setpv(ST(index), string)

#define	USER_NAME				0
#define USER_PASSWORD			1
#define	USER_PASSWORD_AGE		2
#define	USER_PRIV				3
#define	USER_HOME_DIR			4
#define	USER_COMMENT			5
#define USER_FLAGS				6
#define	USER_SCRIPT_PATH		7
#define	USER_AUTH_FLAGS			8
#define	USER_FULL_NAME			9
#define	USER_USR_COMMENT		10
#define	USER_PARMS				11
#define	USER_WORKSTATIONS		12
#define	USER_LAST_LOGON			13
#define	USER_LAST_LOGOFF		14
#define	USER_ACCT_EXPIRES		15
#define	USER_MAX_STORAGE		16
#define	USER_UNITS_PER_WEEK		17
#define	USER_LOGON_HOURS		18
#define	USER_BAD_PW_COUNT		19
#define	USER_NUM_LOGONS			20
#define	USER_LOGON_SERVER		21
#define	USER_COUNTRY_CODE		22
#define	USER_CODE_PAGE			23
#define	USER_USER_ID			24
#define	USER_PRIMARY_GROUP_ID	25
#define	USER_PROFILE_DIR		26
#define	USER_HOME_DIR_DRIVE		27
#define	USER_PASSWORD_EXPIRED	28

#define PREFLEN 0x20000

// constant function for exporting NT definitions.

static long constant(CPerl* pPerl, char *name)
{
    errno = 0;
    switch (*name) {
    case 'A':
	break;
    case 'B':
	break;
    case 'C':
	break;
    case 'D':
	break;
    case 'E':
	break;
    case 'F':
	if (strEQ(name, "FILTER_TEMP_DUPLICATE_ACCOUNT"))
#ifdef FILTER_TEMP_DUPLICATE_ACCOUNT
		return FILTER_TEMP_DUPLICATE_ACCOUNT;
#else
		goto not_there;
#endif	
	if (strEQ(name, "FILTER_NORMAL_ACCOUNT"))
#ifdef FILTER_NORMAL_ACCOUNT
		return FILTER_NORMAL_ACCOUNT;
#else
		goto not_there;
#endif	
	if (strEQ(name, "FILTER_INTERDOMAIN_TRUST_ACCOUNT"))
#ifdef FILTER_INTERDOMAIN_TRUST_ACCOUNT
		return FILTER_INTERDOMAIN_TRUST_ACCOUNT;
#else
		goto not_there;
#endif	
	if (strEQ(name, "FILTER_WORKSTATION_TRUST_ACCOUNT"))
#ifdef FILTER_WORKSTATION_TRUST_ACCOUNT
		return FILTER_WORKSTATION_TRUST_ACCOUNT;
#else
		goto not_there;
#endif	
	if (strEQ(name, "FILTER_SERVER_TRUST_ACCOUNT"))
#ifdef FILTER_SERVER_TRUST_ACCOUNT
		return FILTER_SERVER_TRUST_ACCOUNT;
#else
		goto not_there;
#endif	

	break;
    case 'G':
	break;
    case 'H':
	break;
    case 'I':
	break;
    case 'J':
	break;
    case 'K':
	break;
    case 'L':
	break;
    case 'M':
	break;
    case 'N':
	break;
    case 'O':
	break;
    case 'P':
	break;
    case 'Q':
	break;
    case 'R':
	break;
    case 'S':
	if (strEQ(name, "SV_TYPE_WORKSTATION"))
#ifdef SV_TYPE_WORKSTATION
	    return SV_TYPE_WORKSTATION;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_SERVER"))
#ifdef SV_TYPE_SERVER
	    return SV_TYPE_SERVER;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_SQLSERVER"))
#ifdef SV_TYPE_SQLSERVER
	    return SV_TYPE_SQLSERVER;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_DOMAIN_CTRL"))
#ifdef SV_TYPE_DOMAIN_CTRL
	    return SV_TYPE_DOMAIN_CTRL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_DOMAIN_BAKCTRL"))
#ifdef SV_TYPE_DOMAIN_BAKCTRL
	    return SV_TYPE_DOMAIN_BAKCTRL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_TIMESOURCE"))
#ifdef SV_TYPE_TIMESOURCE
	    return SV_TYPE_TIMESOURCE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_AFP"))
#ifdef SV_TYPE_AFP
	    return SV_TYPE_AFP;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_NOVELL"))
#ifdef SV_TYPE_NOVELL
	    return SV_TYPE_NOVELL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_DOMAIN_MEMBER"))
#ifdef SV_TYPE_DOMAIN_MEMBER
	    return SV_TYPE_DOMAIN_MEMBER;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_PRINT"))
#ifdef SV_TYPE_PRINT
	    return SV_TYPE_PRINT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_DIALIN"))
#ifdef SV_TYPE_DIALIN
	    return SV_TYPE_DIALIN;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_XENIX_SERVER"))
#ifdef SV_TYPE_XENIX_SERVER
	    return SV_TYPE_XENIX_SERVER;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_NT"))
#ifdef SV_TYPE_NT
	    return SV_TYPE_NT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_WFW"))
#ifdef SV_TYPE_WFW
	    return SV_TYPE_WFW;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_POTENTIAL_BROWSER"))
#ifdef SV_TYPE_POTENTIAL_BROWSER
	    return SV_TYPE_POTENTIAL_BROWSER;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_BACKUP_BROWSER"))
#ifdef SV_TYPE_BACKUP_BROWSER
	    return SV_TYPE_BACKUP_BROWSER;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_MASTER_BROWSER"))
#ifdef SV_TYPE_MASTER_BROWSER
	    return SV_TYPE_MASTER_BROWSER;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_DOMAIN_MASTER"))
#ifdef SV_TYPE_DOMAIN_MASTER
	    return SV_TYPE_DOMAIN_MASTER;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_DOMAIN_ENUM"))
#ifdef SV_TYPE_DOMAIN_ENUM
	    return SV_TYPE_DOMAIN_ENUM;
#else
	    goto not_there;
#endif
	if (strEQ(name, "SV_TYPE_ALL"))
#ifdef SV_TYPE_ALL
	    return SV_TYPE_ALL;
#else
	    goto not_there;
#endif
	break;
    case 'T':
	if (strEQ(name, "TIMEQ_FOREVER"))
#ifdef TIMEQ_FOREVER
	    return TIMEQ_FOREVER;
#else
	    goto not_there;
#endif
	break;
    case 'U':
	if (strEQ(name, "UF_TEMP_DUPLICATE_ACCOUNT"))
#ifdef UF_TEMP_DUPLICATE_ACCOUNT
	    return UF_TEMP_DUPLICATE_ACCOUNT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "UF_NORMAL_ACCOUNT"))
#ifdef UF_NORMAL_ACCOUNT
	    return UF_NORMAL_ACCOUNT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "UF_INTERDOMAIN_TRUST_ACCOUNT"))
#ifdef UF_INTERDOMAIN_TRUST_ACCOUNT
	    return UF_INTERDOMAIN_TRUST_ACCOUNT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "UF_WORKSTATION_TRUST_ACCOUNT"))
#ifdef UF_WORKSTATION_TRUST_ACCOUNT
	    return UF_WORKSTATION_TRUST_ACCOUNT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "UF_SERVER_TRUST_ACCOUNT"))
#ifdef UF_SERVER_TRUST_ACCOUNT
	    return UF_SERVER_TRUST_ACCOUNT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "UF_MACHINE_ACCOUNT_MASK"))
#ifdef UF_MACHINE_ACCOUNT_MASK
	    return UF_MACHINE_ACCOUNT_MASK;
#else
	    goto not_there;
#endif
	if (strEQ(name, "UF_ACCOUNT_TYPE_MASK"))
#ifdef UF_ACCOUNT_TYPE_MASK
	    return UF_ACCOUNT_TYPE_MASK;
#else
	    goto not_there;
#endif
	if (strEQ(name, "UF_DONT_EXPIRE_PASSWD"))
#ifdef UF_DONT_EXPIRE_PASSWD
	    return UF_DONT_EXPIRE_PASSWD;
#else
	    goto not_there;
#endif
	if (strEQ(name, "UF_SETTABLE_BITS"))
#ifdef UF_SETTABLE_BITS
	    return UF_SETTABLE_BITS;
#else
	    goto not_there;
#endif

	if (strEQ(name, "UF_SCRIPT"))
#ifdef UF_SCRIPT
	    return UF_SCRIPT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "UF_ACCOUNTDISABLE"))
#ifdef UF_ACCOUNTDISABLE
	    return UF_ACCOUNTDISABLE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "UF_HOMEDIR_REQUIRED"))
#ifdef UF_HOMEDIR_REQUIRED
	    return UF_HOMEDIR_REQUIRED;
#else
	    goto not_there;
#endif
	if (strEQ(name, "UF_LOCKOUT"))
#ifdef UF_LOCKOUT
	    return UF_LOCKOUT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "UF_PASSWD_NOTREQD"))
#ifdef UF_PASSWD_NOTREQD
	    return UF_PASSWD_NOTREQD;
#else
	    goto not_there;
#endif
	if (strEQ(name, "UF_PASSWD_CANT_CHANGE"))
#ifdef UF_PASSWD_CANT_CHANGE
	    return UF_PASSWD_CANT_CHANGE;
#else
	    goto not_there;
#endif

	if (strEQ(name, "USE_FORCE"))
#ifdef USE_FORCE
	    return USE_FORCE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USE_LOTS_OF_FORCE"))
#ifdef USE_LOTS_OF_FORCE
	    return USE_LOTS_OF_FORCE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USE_NOFORCE"))
#ifdef USE_NOFORCE
	    return USE_NOFORCE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_PRIV_MASK"))
#ifdef USER_PRIV_MASK
	    return USER_PRIV_MASK;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_PRIV_GUEST"))
#ifdef USER_PRIV_GUEST
	    return USER_PRIV_GUEST;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_PRIV_USER"))
#ifdef USER_PRIV_USER
	    return USER_PRIV_USER;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_PRIV_ADMIN"))
#ifdef USER_PRIV_ADMIN
	    return USER_PRIV_ADMIN;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_MAXSTORAGE_UNLIMITED"))
#ifdef USER_MAXSTORAGE_UNLIMITED
	    return USER_MAXSTORAGE_UNLIMITED;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_NAME"))
#ifdef USER_NAME
	    return USER_NAME;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_PASSWORD"))
#ifdef USER_PASSWORD
	    return USER_PASSWORD;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_PASSWORD_AGE"))
#ifdef USER_PASSWORD_AGE
	    return USER_PASSWORD_AGE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_PRIV"))
#ifdef USER_PRIV
	    return USER_PRIV;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_HOME_DIR"))
#ifdef USER_HOME_DIR
	    return USER_HOME_DIR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_COMMENT"))
#ifdef USER_COMMENT
	    return USER_COMMENT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_FLAGS"))
#ifdef USER_FLAGS
	    return USER_FLAGS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_SCRIPT_PATH"))
#ifdef USER_SCRIPT_PATH
	    return USER_SCRIPT_PATH;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_AUTH_FLAGS"))
#ifdef USER_AUTH_FLAGS
	    return USER_AUTH_FLAGS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_FULL_NAME"))
#ifdef USER_FULL_NAME
	    return USER_FULL_NAME;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_USR_COMMENT"))
#ifdef USER_USR_COMMENT
	    return USER_USR_COMMENT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_PARMS"))
#ifdef USER_PARMS
	    return USER_PARMS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_WORKSTATIONS"))
#ifdef USER_WORKSTATIONS
	    return USER_WORKSTATIONS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_LAST_LOGON"))
#ifdef USER_LAST_LOGON
	    return USER_LAST_LOGON;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_LAST_LOGOFF"))
#ifdef USER_LAST_LOGOFF
	    return USER_LAST_LOGOFF;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_ACCT_EXPIRES"))
#ifdef USER_ACCT_EXPIRES
	    return USER_ACCT_EXPIRES;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_MAX_STORAGE"))
#ifdef USER_MAX_STORAGE
	    return USER_MAX_STORAGE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_UNITS_PER_WEEK"))
#ifdef USER_UNITS_PER_WEEK
	    return USER_UNITS_PER_WEEK;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_LOGON_HOURS"))
#ifdef USER_LOGON_HOURS
	    return USER_LOGON_HOURS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_BAD_PW_COUNT"))
#ifdef USER_BAD_PW_COUNT
	    return USER_BAD_PW_COUNT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_NUM_LOGONS"))
#ifdef USER_NUM_LOGONS
	    return USER_NUM_LOGONS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_LOGON_SERVER"))
#ifdef USER_LOGON_SERVER
	    return USER_LOGON_SERVER;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_COUNTRY_CODE"))
#ifdef USER_COUNTRY_CODE
	    return USER_COUNTRY_CODE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_CODE_PAGE"))
#ifdef USER_CODE_PAGE
	    return USER_CODE_PAGE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_USER_ID"))
#ifdef USER_USER_ID
	    return USER_USER_ID;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_PRIMARY_GROUP_ID"))
#ifdef USER_PRIMARY_GROUP_ID
	    return USER_PRIMARY_GROUP_ID;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_PROFILE_DIR"))
#ifdef USER_PROFILE_DIR
	    return USER_PROFILE_DIR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_HOME_DIR_DRIVE"))
#ifdef USER_HOME_DIR_DRIVE
	    return USER_HOME_DIR_DRIVE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "USER_PASSWORD_EXPIRED"))
#ifdef USER_PASSWORD_EXPIRED
	    return USER_PASSWORD_EXPIRED;
#else
	    goto not_there;
#endif

	break;
    case 'V':
	break;
    case 'W':
	break;
    case 'X':
	break;
    case 'Y':
	break;
    case 'Z':
	break;
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

#undef malloc
#undef free
void AllocWideName(char* name, LPWSTR &lpPtr)
{
	int length;

	lpPtr = NULL;
	if(name != NULL && *name != '\0')
	{
		length = (strlen(name)+1) * sizeof(WCHAR);
		lpPtr = (LPWSTR)malloc(length);
		if(lpPtr != NULL)
			MultiByteToWideChar(CP_ACP, NULL, name, -1, lpPtr, length);
	}
}

void AllocNarrowName(char* name, LPSTR &lpPtr)
{
	int length;

	lpPtr = NULL;
	if(name != NULL && *name != '\0')
	{
		length = (strlen(name)+1) * sizeof(char);
		lpPtr = (LPSTR)malloc(length);
		if(lpPtr != NULL)
			strcpy(lpPtr, name );
	}
}


inline void FreeWideName(LPWSTR lpPtr)
{
	if(lpPtr != NULL)
		free(lpPtr);
}



inline int WCTMB(LPWSTR lpwStr, LPSTR lpStr, int size)
{
	*lpStr = '\0';
	return WideCharToMultiByte(CP_ACP, NULL, lpwStr, -1, lpStr, size, NULL, NULL);
}

static DWORD lastError = 0;

XS(XS_NT__UserAdmin_GetError)
{
	dSP;
	PUSHMARK(sp);
	XPUSHs(newSViv(lastError));
	PUTBACK;
}

XS(XS_NT__UserAdmin_GetDomainController)
{
	dXSARGS;
	char buffer[512];
	LPWSTR lpwServer, lpwDomain, lpwPrimaryDC = NULL;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::GetDomainController(server, domain, returnedName)\n");
	}
	{
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwDomain);
		lastError = NetGetDCName(lpwServer, lpwDomain, (LPBYTE *)&lpwPrimaryDC);
		if(lastError == 0)
		{
			WCTMB(lpwPrimaryDC, buffer, sizeof(buffer));
			SETPV(2, buffer);
			NetApiBufferFree(lpwPrimaryDC);
		}
		FreeWideName(lpwServer);
		FreeWideName(lpwDomain);
	}
	RETURNRESULT(lastError == 0);
}


XS(XS_NT__UserAdmin_constant)
{
	dXSARGS;

	if (items != 2)
	{
		croak("Usage: Win32::UserAdmin::constant(name, arg)\n");
	}
	{
		char* name = (char*)SvPV(ST(0),na);
		ST(0) = sv_newmortal();
		sv_setiv(ST(0), constant(pPerl, name));
	}
	XSRETURN(1);
}

/**********************************************************************************/
/* This section has been changed in order to accomodate the USER_INFO_3 structure */
/**********************************************************************************/

void LogonHoursToString(char* &lpwLogonHours, PBYTE &pbLogonHours) {

	if(pbLogonHours != NULL) {
		lpwLogonHours = new char[169];
		unsigned char tempByte;
		int i = 0, j = 0;
		for(i - 0; i < 21; i++) {
			tempByte = pbLogonHours[i];
			for(j = 0; j < 8; j++) {
				if((tempByte << 7 - j) >> 7)
					lpwLogonHours[i*8+j] = '1';
				else lpwLogonHours[i*8+j] = '0';
			}
		}
		lpwLogonHours[168] = '\0';
	}

}

void LogonHoursToByte(char* lpwLogonHours, PBYTE &pbLogonHours) {
	int i = 0, j = 0;
	unsigned char tempByte;
	if(lpwLogonHours != NULL) {
		pbLogonHours = new unsigned char[21];
		for(i = 0; i < 21; i++) 
			pbLogonHours[i] = 0x00;
		for(i = 0; i < 21; i++) {
			tempByte = 0x00;
			for(j = 0; j < 8; j++) {
				if(lpwLogonHours[i*8+j] == '1')
					tempByte |= (0x01 << j);
			}
			pbLogonHours[i] = tempByte;
		}
	}
}



void FillUserInfo3Struct(CPerl *pPerl, HV* userInfoList, USER_INFO_3 &uiUser) {
	SV **psv;

	psv = hv_fetch(userInfoList, "USER_NAME", 9, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri3_name);
	psv = hv_fetch(userInfoList, "USER_PASSWORD", 13, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri3_password);
	psv = hv_fetch(userInfoList, "USER_HOME_DIR", 13, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri3_home_dir);
	psv = hv_fetch(userInfoList, "USER_COMMENT", 12, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri3_comment);
	psv = hv_fetch(userInfoList, "USER_FLAGS", 10, 0);
	uiUser.usri3_flags			= SvIV(*psv);
	psv = hv_fetch(userInfoList, "USER_SCRIPT_PATH", 16, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri3_script_path);
	uiUser.usri3_auth_flags = 0;
	psv = hv_fetch(userInfoList, "USER_FULL_NAME", 14, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri3_full_name);
	psv = hv_fetch(userInfoList, "USER_USR_COMMENT", 16, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri3_usr_comment);
	psv = hv_fetch(userInfoList, "USER_PARMS", 10, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri3_parms);
	psv = hv_fetch(userInfoList, "USER_WORKSTATIONS", 17, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri3_workstations);
	psv = hv_fetch(userInfoList, "USER_ACCT_EXPIRES", 17, 0);
	uiUser.usri3_acct_expires			= SvIV(*psv);
	psv = hv_fetch(userInfoList, "USER_MAX_STORAGE", 16, 0);
	uiUser.usri3_max_storage			= SvIV(*psv);
	uiUser.usri3_units_per_week			= 168;
	psv = hv_fetch(userInfoList, "USER_LOGON_HOURS", 16, 0);
	LogonHoursToByte((char*)SvPV(*psv,na), uiUser.usri3_logon_hours);
	psv = hv_fetch(userInfoList, "USER_COUNTRY_CODE", 17, 0);
	uiUser.usri3_country_code			= SvIV(*psv);
	psv = hv_fetch(userInfoList, "USER_CODE_PAGE", 14, 0);
	uiUser.usri3_code_page			= SvIV(*psv);
	uiUser.usri3_primary_group_id			= DOMAIN_GROUP_RID_USERS;
	psv = hv_fetch(userInfoList, "USER_PROFILE", 12, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri3_profile);
	psv = hv_fetch(userInfoList, "USER_HOME_DIR_DRIVE", 19, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri3_home_dir_drive);
	psv = hv_fetch(userInfoList, "USER_PASSWORD_EXPIRED", 21, 0);
	uiUser.usri3_password_expired			= SvIV(*psv);

}

void FillUserInfo2Struct(CPerl *pPerl, HV* userInfoList, USER_INFO_2 &uiUser) {
	SV **psv;

	psv = hv_fetch(userInfoList, "USER_NAME", 9, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri2_name);
	psv = hv_fetch(userInfoList, "USER_PASSWORD", 13, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri2_password);
	psv = hv_fetch(userInfoList, "USER_HOME_DIR", 13, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri2_home_dir);
	psv = hv_fetch(userInfoList, "USER_COMMENT", 12, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri2_comment);
	psv = hv_fetch(userInfoList, "USER_FLAGS", 10, 0);
	uiUser.usri2_flags			= SvIV(*psv);
	psv = hv_fetch(userInfoList, "USER_SCRIPT_PATH", 16, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri2_script_path);
	uiUser.usri2_auth_flags = 0;
	psv = hv_fetch(userInfoList, "USER_FULL_NAME", 14, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri2_full_name);
	psv = hv_fetch(userInfoList, "USER_USR_COMMENT", 16, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri2_usr_comment);
	psv = hv_fetch(userInfoList, "USER_PARMS", 10, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri2_parms);
	psv = hv_fetch(userInfoList, "USER_WORKSTATIONS", 17, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri2_workstations);
	psv = hv_fetch(userInfoList, "USER_ACCT_EXPIRES", 17, 0);
	uiUser.usri2_acct_expires			= SvIV(*psv);
	psv = hv_fetch(userInfoList, "USER_MAX_STORAGE", 16, 0);
	uiUser.usri2_max_storage			= SvIV(*psv);
	uiUser.usri2_units_per_week			= 168;
	psv = hv_fetch(userInfoList, "USER_LOGON_HOURS", 16, 0);
	LogonHoursToByte((char*)SvPV(*psv,na), uiUser.usri2_logon_hours);
	psv = hv_fetch(userInfoList, "USER_COUNTRY_CODE", 17, 0);
	uiUser.usri2_country_code			= SvIV(*psv);
	psv = hv_fetch(userInfoList, "USER_CODE_PAGE", 14, 0);
	uiUser.usri2_code_page			= SvIV(*psv);

}

void FillUserInfo1Struct(CPerl *pPerl, HV* userInfoList, USER_INFO_1 &uiUser) {
	SV **psv;


	psv = hv_fetch(userInfoList, "USER_NAME", 9, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri1_name);
	psv = hv_fetch(userInfoList, "USER_PASSWORD", 13, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri1_password);
	psv = hv_fetch(userInfoList, "USER_HOME_DIR", 13, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri1_home_dir);
	psv = hv_fetch(userInfoList, "USER_COMMENT", 12, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri1_comment);
	psv = hv_fetch(userInfoList, "USER_FLAGS", 10, 0);
	uiUser.usri1_flags			= SvIV(*psv);
	psv = hv_fetch(userInfoList, "USER_SCRIPT_PATH", 16, 0);
	AllocWideName((char*)SvPV(*psv,na), uiUser.usri1_script_path);

}


XS(XS_NT__UserAdmin_UserCreate)
{
	dXSARGS;
	LPWSTR lpwServer;
	DWORD level;

	if (items != 3) {
		croak("Usage: Win32::UserAdmin::UserCreate(server, level, \\%userInfo)\n");
	}
	SV* sv = ST(2);
	if(SvROK(sv)) {
		sv = SvRV(sv);
	}
	if(SvTYPE(sv) == SVt_PVHV) {			
		level = SvIV(ST(1));
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);

		if(level == 1) {
			USER_INFO_1 puiUser;
			FillUserInfo1Struct(pPerl, (HV*)sv, puiUser);
			lastError = NetUserAdd(lpwServer, 1, (LPBYTE)&puiUser, NULL);
		} else if(level == 2) {
			USER_INFO_2 puiUser;
			FillUserInfo2Struct(pPerl, (HV*)sv, puiUser);
			lastError = NetUserAdd(lpwServer, level, (LPBYTE)&puiUser, NULL);
		} else if(level == 3) {
			USER_INFO_3 puiUser;
			FillUserInfo3Struct(pPerl, (HV*)sv, puiUser);
			lastError = NetUserAdd(lpwServer, level, (LPBYTE)&puiUser, NULL);
		}

		FreeWideName(lpwServer);


	} else {
		croak("Usage: Win32::UserAdmin::UserCreate(server, level, \\%userInfo)\n");
	}
	RETURNRESULT(lastError == 0);
}


/****************************END*CHANGES*******************************/

XS(XS_NT__UserAdmin_UserDelete)
{
	dXSARGS;
	LPWSTR lpwServer, lpwUser;

	if (items != 2)
	{
		croak("Usage: Win32::UserAdmin::UserDelete(server, user)\n");
	}
	{
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwUser);
		lastError = NetUserDel(lpwServer, lpwUser);
		FreeWideName(lpwServer);
		FreeWideName(lpwUser);
	}
	RETURNRESULT(lastError == 0);
}

/*************************************************************************/
/* this section has been changed to accomodate the USER_INFO_3 structure */
/*************************************************************************/


void FillUserInfo3List(CPerl *pPerl, HV* userInfoList, PUSER_INFO_3 puiUser) {
	char buffer[UNLEN+1];
	char* lpwLogonHours;
	
	WCTMB(puiUser->usri3_name, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_NAME", 9, newSVpv(buffer, 0), 0);
	WCTMB(puiUser->usri3_password, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_PASSWORD", 13, newSVpv(buffer,0), 0);
	hv_store(userInfoList, "USER_PASSWORD_AGE", 17, newSViv(puiUser->usri3_password_age), 0);
	hv_store(userInfoList, "USER_PRIV", 9, newSViv(puiUser->usri3_priv), 0);
	WCTMB(puiUser->usri3_home_dir, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_HOME_DIR", 13, newSVpv(buffer,0), 0);
	WCTMB(puiUser->usri3_comment, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_COMMENT", 12, newSVpv(buffer, 0), 0);
	hv_store(userInfoList, "USER_FLAGS", 10, newSViv(puiUser->usri3_flags), 0);
	WCTMB(puiUser->usri3_script_path, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_SCRIPT_PATH", 16, newSVpv(buffer, 0), 0);
	hv_store(userInfoList, "USER_AUTH_FLAGS", 15, newSViv(puiUser->usri3_auth_flags), 0);
	WCTMB(puiUser->usri3_full_name, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_FULL_NAME", 14, newSVpv(buffer,0), 0);
	WCTMB(puiUser->usri3_usr_comment, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_USR_COMMENT", 16, newSVpv(buffer,0), 0);
	WCTMB(puiUser->usri3_parms, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_PARMS", 10, newSVpv(buffer,0), 0);
	WCTMB(puiUser->usri3_workstations, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_WORKSTATIONS", 17, newSVpv(buffer,0), 0);
	hv_store(userInfoList, "USER_LAST_LOGON", 15, newSViv(puiUser->usri3_last_logon), 0);
	hv_store(userInfoList, "USER_LAST_LOGOFF", 16, newSViv(puiUser->usri3_last_logoff), 0);
	hv_store(userInfoList, "USER_ACCT_EXPIRES", 17, newSViv(puiUser->usri3_acct_expires), 0);
	hv_store(userInfoList, "USER_MAX_STORAGE", 16, newSViv(puiUser->usri3_max_storage), 0);
	hv_store(userInfoList, "USER_UNITS_PER_WEEK", 19, newSViv(puiUser->usri3_units_per_week), 0);
	LogonHoursToString(lpwLogonHours, puiUser->usri3_logon_hours);
	hv_store(userInfoList, "USER_LOGON_HOURS", 16, newSVpv(lpwLogonHours,0), 0);
	hv_store(userInfoList, "USER_BAD_PW_ACCOUNT", 19, newSViv(puiUser->usri3_bad_pw_count), 0);
	hv_store(userInfoList, "USER_NUM_LOGONS", 15, newSViv(puiUser->usri3_num_logons), 0);
	WCTMB(puiUser->usri3_logon_server, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_LOGON_SERVER", 17, newSVpv(buffer,0), 0);
	hv_store(userInfoList, "USER_COUNTRY_CODE", 17, newSViv(puiUser->usri3_country_code), 0);
	hv_store(userInfoList, "USER_CODE_PAGE", 14, newSViv(puiUser->usri3_code_page), 0);
	hv_store(userInfoList, "USER_USER_ID", 12, newSViv(puiUser->usri3_user_id), 0);
	hv_store(userInfoList, "USER_PRIMARY_GROUP_ID", 21, newSViv(puiUser->usri3_primary_group_id), 0);
	WCTMB(puiUser->usri3_profile, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_PROFILE", 12, newSVpv(buffer,0), 0);
	WCTMB(puiUser->usri3_home_dir_drive, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_HOME_DIR_DRIVE", 19, newSVpv(buffer,0), 0);
	hv_store(userInfoList, "USER_PASSWORD_EXPIRED", 21, newSViv(puiUser->usri3_password_expired), 0);

	NetApiBufferFree(puiUser);
	delete(lpwLogonHours);
}

void FillUserInfo2List(CPerl *pPerl, HV* userInfoList, PUSER_INFO_2 puiUser) {
	char buffer[UNLEN+1];
	char* lpwLogonHours;

	WCTMB(puiUser->usri2_name, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_NAME", 9, newSVpv(buffer, 0), 0);
	WCTMB(puiUser->usri2_password, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_PASSWORD", 13, newSVpv(buffer,0), 0);
	hv_store(userInfoList, "USER_PASSWORD_AGE", 17, newSViv(puiUser->usri2_password_age), 0);
	hv_store(userInfoList, "USER_PRIV", 9, newSViv(puiUser->usri2_priv), 0);
	WCTMB(puiUser->usri2_home_dir, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_HOME_DIR", 13, newSVpv(buffer,0), 0);
	WCTMB(puiUser->usri2_comment, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_COMMENT", 12, newSVpv(buffer, 0), 0);
	hv_store(userInfoList, "USER_FLAGS", 10, newSViv(puiUser->usri2_flags), 0);
	WCTMB(puiUser->usri2_script_path, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_SCRIPT_PATH", 16, newSVpv(buffer, 0), 0);
	hv_store(userInfoList, "USER_AUTH_FLAGS", 15, newSViv(puiUser->usri2_auth_flags), 0);
	WCTMB(puiUser->usri2_full_name, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_FULL_NAME", 14, newSVpv(buffer,0), 0);
	WCTMB(puiUser->usri2_usr_comment, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_USR_COMMENT", 16, newSVpv(buffer,0), 0);
	WCTMB(puiUser->usri2_parms, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_PARMS", 10, newSVpv(buffer,0), 0);
	WCTMB(puiUser->usri2_workstations, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_WORKSTATIONS", 17, newSVpv(buffer,0), 0);
	hv_store(userInfoList, "USER_LAST_LOGON", 15, newSViv(puiUser->usri2_last_logon), 0);
	hv_store(userInfoList, "USER_LAST_LOGOFF", 16, newSViv(puiUser->usri2_last_logoff), 0);
	hv_store(userInfoList, "USER_ACCT_EXPIRES", 17, newSViv(puiUser->usri2_acct_expires), 0);
	hv_store(userInfoList, "USER_MAX_STORAGE", 16, newSViv(puiUser->usri2_max_storage), 0);
	hv_store(userInfoList, "USER_UNITS_PER_WEEK", 19, newSViv(puiUser->usri2_units_per_week), 0);
	LogonHoursToString(lpwLogonHours, puiUser->usri2_logon_hours);
	hv_store(userInfoList, "USER_LOGON_HOURS", 16, newSVpv(lpwLogonHours,0), 0);
	hv_store(userInfoList, "USER_BAD_PW_ACCOUNT", 19, newSViv(puiUser->usri2_bad_pw_count), 0);
	hv_store(userInfoList, "USER_NUM_LOGONS", 15, newSViv(puiUser->usri2_num_logons), 0);
	WCTMB(puiUser->usri2_logon_server, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_LOGON_SERVER", 17, newSVpv(buffer,0), 0);
	hv_store(userInfoList, "USER_COUNTRY_CODE", 17, newSViv(puiUser->usri2_country_code), 0);
	hv_store(userInfoList, "USER_CODE_PAGE", 14, newSViv(puiUser->usri2_code_page), 0);

	NetApiBufferFree(puiUser);
	delete(lpwLogonHours);
}

void FillUserInfo1List(CPerl *pPerl, HV* userInfoList, PUSER_INFO_1 puiUser) {
	char buffer[UNLEN+1];

	WCTMB(puiUser->usri1_name, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_NAME", 9, newSVpv(buffer, 0), 0);
	WCTMB(puiUser->usri1_password, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_PASSWORD", 13, newSVpv(buffer,0), 0);
	hv_store(userInfoList, "USER_PASSWORD_AGE", 17, newSViv(puiUser->usri1_password_age), 0);
	hv_store(userInfoList, "USER_PRIV", 9, newSViv(puiUser->usri1_priv), 0);
	WCTMB(puiUser->usri1_home_dir, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_HOME_DIR", 13, newSVpv(buffer,0), 0);
	WCTMB(puiUser->usri1_comment, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_COMMENT", 12, newSVpv(buffer, 0), 0);
	hv_store(userInfoList, "USER_FLAGS", 10, newSViv(puiUser->usri1_flags), 0);
	WCTMB(puiUser->usri1_script_path, buffer, sizeof(buffer));
	hv_store(userInfoList, "USER_SCRIPT_PATH", 16, newSVpv(buffer, 0), 0);

	NetApiBufferFree(puiUser);
}

XS(XS_NT__UserAdmin_UserGetAttributes)
{
	dXSARGS;
	LPWSTR lpwServer, lpwUser;
	DWORD level;
	PUSER_INFO_1 puiUser;
	if (items != 4) {
		croak("Usage: Win32::UserAdmin::UserGetAttributes(server, userName, level, \\@userInfo)\n");
	}
	SV* sv = ST(3);
	if(SvROK(sv)) {
			sv = SvRV(sv);
	}
	if(SvTYPE(sv) == SVt_PVHV) {
		hv_clear((HV*)sv);
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwUser);
		level = SvIV(ST(2));
		if(level == 1) PUSER_INFO_1 puiUser;
		else if(level == 2) PUSER_INFO_2 puiUser;
		else if(level == 3) PUSER_INFO_3 puiUser;
		else {
			croak("Win32::UserAdmin::UserGetAttributes: level argument must be 1 to 3\n");
		}

		lastError = NetUserGetInfo(lpwServer, lpwUser, level, (LPBYTE*)&puiUser);
		if(lastError == 0)
		{
			switch(level) {
			case 1: FillUserInfo1List(pPerl, (HV*)sv, (PUSER_INFO_1) puiUser);
				break;
			case 2: FillUserInfo2List(pPerl, (HV*)sv, (PUSER_INFO_2) puiUser);
				break;
			case 3: FillUserInfo3List(pPerl, (HV*)sv, (PUSER_INFO_3) puiUser);
				break;
			}
		}

		FreeWideName(lpwServer);
		FreeWideName(lpwUser);
	} else {
		croak("Usage: Win32::UserAdmin::UserGetAttributes(server, userName, level, \\@userInfo)\n");
	}
	RETURNRESULT(lastError == 0);
}


XS(XS_NT__UserAdmin_UserSetAttributes)
{
	dXSARGS;
	LPWSTR lpwServer;
	LPWSTR lpwUsername;
	DWORD level;

	if (items != 4) {
		croak("Usage: Win32::UserAdmin::UserSetAttributeList(server, username, level, \\userInfo)\n");
	}
	SV* sv = ST(3);
	if(SvROK(sv)) {
		sv = SvRV(sv);
	}
	if(SvTYPE(sv) == SVt_PVHV) {			
		level = SvIV(ST(2));
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwUsername);

		if(level == 1) {
			USER_INFO_1 puiUser;
			FillUserInfo1Struct(pPerl, (HV*)sv, puiUser);
			//puiUser.usri1_password = NULL;
			lastError = NetUserSetInfo(lpwServer, lpwUsername,  1, (LPBYTE)&puiUser, NULL);
		} else if(level == 2) {
			USER_INFO_2 puiUser;
			FillUserInfo2Struct(pPerl, (HV*)sv, puiUser);
			lastError = NetUserSetInfo(lpwServer, lpwUsername, level, (LPBYTE)&puiUser, NULL);
		} else if(level == 3) {
			USER_INFO_3 puiUser;
			FillUserInfo3Struct(pPerl, (HV*)sv, puiUser);
			lastError = NetUserSetInfo(lpwServer, lpwUsername, level, (LPBYTE)&puiUser, NULL);
		}

		FreeWideName(lpwServer);
		FreeWideName(lpwUsername);

	} else {
		croak("Usage: Win32::UserAdmin::UserSetAttributeList(server, username, level, \\userInfo)\n");
	}

	RETURNRESULT(lastError == 0);
}


XS(XS_NT__UserAdmin_UserGetGroups) {
	dXSARGS;
	LPWSTR lpwServer;
	LPWSTR lpwUsername;
	char buffer[UNLEN+1];
	PGROUP_USERS_INFO_0 pwzUserGroups;
	DWORD entriesRead, totalEntries;
	int index;
	SV *sv, *nSv;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::GetUserGroups(server, username, \\@groupArray)\n");
	}
	{	
	
		sv = ST(2);
		if(SvROK(sv))
		{
			sv = SvRV(sv);
		}
		if(SvTYPE(sv) == SVt_PVAV)
		{
			av_clear((AV*)sv);
			AllocWideName((char*)SvPV(ST(0),na), lpwServer);
			AllocWideName((char*)SvPV(ST(1),na), lpwUsername);
			lastError = NetUserGetGroups(lpwServer, lpwUsername, 0, 
						(LPBYTE*)&pwzUserGroups, PREFLEN, &entriesRead, 
						&totalEntries);

			for(index = 0; index < entriesRead; ++index)
				{
					WCTMB(pwzUserGroups[index].grui0_name, buffer, sizeof(buffer));
					av_push((AV*)sv, newSVpv(buffer, 0));
				}
				NetApiBufferFree(pwzUserGroups);
			FreeWideName(lpwServer);
			FreeWideName(lpwUsername);
		}
		else
		{
			croak("Usage: Win32::UserAdmin::GetUserGroups(server, username, \\@groupArray)\nuserArray was not an array\n");
		}
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_UserGetLocalGroups) {
	dXSARGS;
	LPWSTR lpwServer;
	LPWSTR lpwUsername;
	char buffer[UNLEN+1];
	PGROUP_USERS_INFO_0 pwzUserGroups;
	DWORD entriesRead, totalEntries;
	int index;
	SV *sv, *nSv;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::GetUserLocalGroups(server, username, \\@groupArray)\n");
	}
	{	
	
		sv = ST(2);
		if(SvROK(sv))
		{
			sv = SvRV(sv);
		}
		if(SvTYPE(sv) == SVt_PVAV)
		{
			av_clear((AV*)sv);
			AllocWideName((char*)SvPV(ST(0),na), lpwServer);
			AllocWideName((char*)SvPV(ST(1),na), lpwUsername);
			lastError = NetUserGetLocalGroups(lpwServer, lpwUsername, 0,
						LG_INCLUDE_INDIRECT, (LPBYTE*)&pwzUserGroups, 
						PREFLEN, &entriesRead, &totalEntries);

			for(index = 0; index < entriesRead; ++index)
				{
					WCTMB(pwzUserGroups[index].grui0_name, buffer, sizeof(buffer));
					av_push((AV*)sv, newSVpv(buffer, 0));
				}
				NetApiBufferFree(pwzUserGroups);
			FreeWideName(lpwServer);
			FreeWideName(lpwUsername);
		}
		else
		{
			croak("Usage: Win32::UserAdmin::GetUserLocalGroups(server, username, \\@groupArray)\nuserArray was not an array\n");
		}
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_GetGroups) {
	dXSARGS;
	LPWSTR lpwServer;
	char buffer[UNLEN+1];
	PGROUP_INFO_0 pwzGroups;
	DWORD entriesRead, totalEntries, resumeHandle = 0;
	int index;
	SV *sv, *nSv;

	if (items != 2)
	{
		croak("Usage: Win32::UserAdmin::GetGroups(server, \\@groupArray)\n");
	}
	{	
	
		sv = ST(1);
		if(SvROK(sv))
		{
			sv = SvRV(sv);
		}
		if(SvTYPE(sv) == SVt_PVAV)
		{
			av_clear((AV*)sv);
			AllocWideName((char*)SvPV(ST(0),na), lpwServer);
			do
			{
				lastError = NetGroupEnum(lpwServer, 0, (LPBYTE*)&pwzGroups,
							PREFLEN, &entriesRead, &totalEntries, &resumeHandle);

				if(lastError != 0)
					break;

				for(index = 0; index < entriesRead; ++index)
				{
					WCTMB(pwzGroups[index].grpi0_name, buffer, sizeof(buffer));
					av_push((AV*)sv, newSVpv(buffer, 0));
				}
				NetApiBufferFree(pwzGroups);
			}
			while((entriesRead != 0) && (resumeHandle != 0));
			FreeWideName(lpwServer);
		}
		else
		{
			croak("Usage: Win32::UserAdmin::GetGroups(server, \\@groupArray)\nuserArray was not an array\n");
		}
	}
	RETURNRESULT(lastError == 0);
}


void FillShareInfoList(CPerl *pPerl, HV* shareInfoList, PSHARE_INFO_2 puiShare) {
	char buffer[UNLEN+1];

	WCTMB((unsigned short*)puiShare->shi2_netname, buffer, sizeof(buffer));
	hv_store(shareInfoList, "SHARE_NET_NAME", 14, newSVpv(buffer, 0), 0);
	hv_store(shareInfoList, "SHARE_TYPE", 10, newSViv(puiShare->shi2_type), 0);
	WCTMB((unsigned short*)puiShare->shi2_remark, buffer, sizeof(buffer));
	hv_store(shareInfoList, "SHARE_REMARK", 12, newSVpv(buffer,0), 0);
	hv_store(shareInfoList, "SHARE_PERMISSIONS", 17, newSViv(puiShare->shi2_permissions), 0);
	hv_store(shareInfoList, "SHARE_MAX_USERS", 15, newSViv(puiShare->shi2_max_uses), 0);
	hv_store(shareInfoList, "SHARE_CURRENT_USERS", 19, newSViv(puiShare->shi2_current_uses), 0);
	WCTMB((unsigned short*)puiShare->shi2_path, buffer, sizeof(buffer));
	hv_store(shareInfoList, "SHARE_PATH", 10, newSVpv(buffer, 0), 0);
	WCTMB((unsigned short*)puiShare->shi2_passwd, buffer, sizeof(buffer));
	hv_store(shareInfoList, "SHARE_PASSWORD", 12, newSVpv(buffer, 0), 0);

	NetApiBufferFree(puiShare);
}

void FillShareInfoStruct(CPerl *pPerl, HV* shareInfoList, SHARE_INFO_2 &puiShare) {
	SV **psv;

	psv = hv_fetch(shareInfoList, "SHARE_NET_NAME", 14, 0);
	AllocNarrowName((char*)SvPV(*psv,na), puiShare.shi2_netname);

	psv = hv_fetch(shareInfoList, "SHARE_TYPE", 10, 0);
	puiShare.shi2_type 			= SvIV(*psv);

	psv = hv_fetch(shareInfoList, "SHARE_REMARK", 12, 0);
	AllocNarrowName((char*)SvPV(*psv,na), puiShare.shi2_remark);

	psv = hv_fetch(shareInfoList, "SHARE_PERMISSIONS", 17, 0);
	puiShare.shi2_permissions			= SvIV(*psv);

	psv = hv_fetch(shareInfoList, "SHARE_MAX_USERS", 15, 0);
	puiShare.shi2_max_uses			= SvIV(*psv);

	psv = hv_fetch(shareInfoList, "SHARE_CURRENT_USERS", 19, 0);
	puiShare.shi2_current_uses			= SvIV(*psv);

	psv = hv_fetch(shareInfoList, "SHARE_PATH", 10, 0);
	AllocNarrowName((char*)SvPV(*psv,na), puiShare.shi2_path);

	psv = hv_fetch(shareInfoList, "SHARE_PASSWORD", 14, 0);
	AllocNarrowName((char*)SvPV(*psv,na), puiShare.shi2_passwd);

}



XS(XS_NT__UserAdmin_NetShareGetInfo) {
	dXSARGS;
	char buffer[UNLEN+2];
	LPWSTR lpwServer, lpwNetName;
	PSHARE_INFO_2 puiShareInfo;
	if (items != 3) {
		croak("Usage: Win32::UserAdmin::NetShareGetInfo(server, netname, \\%shareInfo)\n");
	}
	SV* sv = ST(2);
	if(SvROK(sv)) {
			sv = SvRV(sv);
	}
	if(SvTYPE(sv) == SVt_PVHV) {
		hv_clear((HV*)sv);
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwNetName);

		lastError = NetShareGetInfo((char*)lpwServer, (char*)lpwNetName, 2, (LPBYTE*)&puiShareInfo);
		if(lastError == 0)
		{
			FillShareInfoList(pPerl, (HV*) sv, (PSHARE_INFO_2) puiShareInfo);
		}

	} else {
		croak("Usage: Win32::UserAdmin::NetShareSetInfo(server, netname, \\%shareInfo)\n");
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_NetShareSetInfo) {
	dXSARGS;
	LPWSTR lpwServer, lpwNetName;
	SHARE_INFO_2 puiShareInfo;
	if (items != 3) {
		croak("Usage: Win32::UserAdmin::NetShareGetInfo(server, netname, \\%shareInfo)\n");
	}
	SV* sv = ST(2);
	if(SvROK(sv)) {
			sv = SvRV(sv);
	}
	if(SvTYPE(sv) == SVt_PVHV) {
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwNetName);

		FillShareInfoStruct(pPerl, (HV*) sv, (SHARE_INFO_2) puiShareInfo);

		lastError = NetShareSetInfo((char*)lpwServer, (char*)lpwNetName, 2, (LPBYTE)&puiShareInfo, NULL);

	} else {
		croak("Usage: Win32::UserAdmin::NetShareSetInfo(server, netname, \\%shareInfo)\n");
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_NetShareAdd) {
	dXSARGS;
	
	LPWSTR lpwServer;
	SHARE_INFO_2 puiShareInfo;
	if (items != 2) {
		croak("Usage: Win32::UserAdmin::NetShareAdd(server, \\%shareInfo)\n");
	}
	SV* sv = ST(1);
	if(SvROK(sv)) {
			sv = SvRV(sv);
	}
	if(SvTYPE(sv) == SVt_PVHV) {
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);

		FillShareInfoStruct(pPerl, (HV*) sv, (SHARE_INFO_2) puiShareInfo);

		lastError = NetShareAdd((char*)lpwServer, 2, (LPBYTE)&puiShareInfo, NULL);

	} else {
		croak("Usage: Win32::UserAdmin::NetShareAdd(server,\\%shareInfo)\n");
	}
	RETURNRESULT(lastError == 0);
}


XS(XS_NT__UserAdmin_NetShareDel) {
	dXSARGS;
	LPWSTR lpwServer, lpwNetName;
	SHARE_INFO_2 puiShareInfo;
	if (items != 2) {
		croak("Usage: Win32::UserAdmin::NetShareDel(server, netname)\n");
	}
	AllocWideName((char*)SvPV(ST(0),na), lpwServer);
	AllocWideName((char*)SvPV(ST(1),na), lpwNetName);

	lastError = NetShareDel((char*)lpwServer, (char*)lpwNetName, 0);

	RETURNRESULT(lastError == 0);
}


/******************************END*CHANGES*********************************/

XS(XS_NT__UserAdmin_UserChangePassword)
{
	dXSARGS;
	LPWSTR lpwDomain;
	LPWSTR lpwUserName;
	LPWSTR lpwOldPassword;
	LPWSTR lpwNewPassword;

	if (items != 4)
	{
		croak("Usage: Win32::UserAdmin::UserChangePassword(domainname, username, oldpassword, newpassword)\n");
	}
	{
		AllocWideName((char*)SvPV(ST(0),na), lpwDomain);
		AllocWideName((char*)SvPV(ST(1),na), lpwUserName);
		AllocWideName((char*)SvPV(ST(2),na), lpwOldPassword);
		AllocWideName((char*)SvPV(ST(3),na), lpwNewPassword);
		lastError = NetUserChangePassword(lpwDomain, lpwUserName, lpwOldPassword,lpwNewPassword);
		FreeWideName(lpwDomain);
		FreeWideName(lpwUserName);
		FreeWideName(lpwOldPassword);
		FreeWideName(lpwNewPassword);
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_UsersExist)
{
	dXSARGS;
	char buffer[UNLEN+1];
	LPWSTR lpwServer, lpwUser;
	PUSER_INFO_0 puiUser;
	BOOL bReturn = FALSE;

	if (items != 2)
	{
		croak("Usage: Win32::UserAdmin::UsersExist(server, userName)\n");
	}
	{
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwUser);
		lastError = NetUserGetInfo(lpwServer, lpwUser, 0, (LPBYTE*)&puiUser);
		if(lastError == 0)
		{
			bReturn = TRUE;
			NetApiBufferFree(puiUser);
		}
		FreeWideName(lpwServer);
		FreeWideName(lpwUser);
	}
	RETURNRESULT(bReturn);
}

XS(XS_NT__UserAdmin_GetUsers)
{
	dXSARGS;
	LPWSTR lpwServer;
	char buffer[UNLEN+1];
	PUSER_INFO_0 pwzUsers;
	DWORD filter, entriesRead, totalEntries, resumeHandle = 0;
	int index;
	SV *sv, *nSv;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::GetUsers(server, filter, \\@userArray)\n");
	}
	{	
		filter = SvIV(ST(1));
		sv = ST(2);
		if(SvROK(sv))
		{
			sv = SvRV(sv);
		}
		if(SvTYPE(sv) == SVt_PVAV)
		{
			av_clear((AV*)sv);
			AllocWideName((char*)SvPV(ST(0),na), lpwServer);
			do
			{
				lastError = NetUserEnum(lpwServer, 0, filter, (LPBYTE*)&pwzUsers,
							PREFLEN, &entriesRead, &totalEntries, &resumeHandle);

				if(lastError != 0)
					break;

				for(index = 0; index < entriesRead; ++index)
				{
					WCTMB(pwzUsers[index].usri0_name, buffer, sizeof(buffer));
					av_push((AV*)sv, newSVpv(buffer, 0));
				}
				NetApiBufferFree(pwzUsers);
			}
			while((entriesRead != 0) && (resumeHandle != 0));
			FreeWideName(lpwServer);
		}
		else
		{
			croak("Usage: Win32::UserAdmin::GetUsers(server, filter, \\@userArray)\nuserArray was not an array\n");
		}
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_GroupCreate)
{
	dXSARGS;
	LPWSTR lpwServer;
	GROUP_INFO_1 groupInfo;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::GroupCreate(server, group, comment)\n");
	}
	{
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), groupInfo.grpi1_name);
		AllocWideName((char*)SvPV(ST(2),na), groupInfo.grpi1_comment);
		lastError = NetGroupAdd(lpwServer, 1, (LPBYTE)&groupInfo, NULL);
		FreeWideName(lpwServer);
		FreeWideName(groupInfo.grpi1_name);
		FreeWideName(groupInfo.grpi1_comment);
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_GroupDelete)
{
	dXSARGS;
	LPWSTR lpwServer, lpwGroup;

	if (items != 2)
	{
		croak("Usage: Win32::UserAdmin::GroupDelete(server, group)\n");
	}
	{
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwGroup);
		lastError = NetGroupDel(lpwServer, lpwGroup);
		FreeWideName(lpwServer);
		FreeWideName(lpwGroup);
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_GroupGetAttributes)
{
	dXSARGS;
	char buffer[UNLEN+1];
	LPWSTR lpwServer, lpwGroup;
	PGROUP_INFO_2 pgroupInfo;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::GroupGetAttributes(server, groupName, comment)\n");
	}
	{
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwGroup);
		lastError = NetGroupGetInfo(lpwServer, lpwGroup, 2, (LPBYTE*)&pgroupInfo);
		if(lastError == 0)
		{
			WCTMB(pgroupInfo->grpi2_name, buffer, sizeof(buffer));
			SETPV(2, buffer);
			NetApiBufferFree(pgroupInfo);
		}
		FreeWideName(lpwServer);
		FreeWideName(lpwGroup);
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_GroupSetAttributes)
{
	dXSARGS;
	LPWSTR lpwServer;
	GROUP_INFO_2 groupInfo;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::GroupSetAttributes(server, groupName, comment)\n");
	}
	{
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), groupInfo.grpi2_name);
		AllocWideName((char*)SvPV(ST(2),na), groupInfo.grpi2_comment);
		groupInfo.grpi2_group_id		= 0;
		groupInfo.grpi2_attributes		= 0;
		lastError = NetGroupSetInfo(lpwServer, groupInfo.grpi2_name, 2, (LPBYTE)&groupInfo, NULL);
		FreeWideName(lpwServer);
		FreeWideName(groupInfo.grpi2_name);
		FreeWideName(groupInfo.grpi2_comment);
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_GroupAddUsers)
{
	dXSARGS;
	LPWSTR lpwServer, lpwGroup;
	WCHAR wzUser[UNLEN+2];
	int count, index;
	SV *sv, **psv;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::GroupAddUsers(server, groupName, users)\n");
	}
	{
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwGroup);
		sv = ST(2);
		if(SvROK(sv))
		{
			sv = SvRV(sv);
		}
		switch(SvTYPE(sv))
		{
			case SVt_PVAV:
				count = av_len((AV*)sv);
				for(index = 0; index <= count; ++index)
				{
					psv = av_fetch((AV*)sv, index, 0);
					if(psv != NULL)
					{
						MultiByteToWideChar(CP_ACP, NULL, (char*)SvPV(*psv,na), -1, wzUser, sizeof(wzUser));
						lastError = NetGroupAddUser(lpwServer, lpwGroup, wzUser);
						if(lastError != 0)
							break;
					}
				}
				break;

			default:
				MultiByteToWideChar(CP_ACP, NULL, (char*)SvPV(sv,na), -1, wzUser, sizeof(wzUser));
				lastError = NetGroupAddUser(lpwServer, lpwGroup, wzUser);
				break;
		}
		FreeWideName(lpwServer);
		FreeWideName(lpwGroup);
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_GroupDeleteUsers)
{
	dXSARGS;
	LPWSTR lpwServer, lpwGroup;
	WCHAR wzUser[UNLEN+2];
	int count, index;
	SV *sv, **psv;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::GroupDelUsers(server, groupName, users)\n");
	}
	{
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwGroup);
		sv = ST(2);
		if(SvROK(sv))
		{
			sv = SvRV(sv);
		}
		switch(SvTYPE(sv))
		{
			case SVt_PVAV:
				count = av_len((AV*)sv);
				for(index = 0; index <= count; ++index)
				{
					psv = av_fetch((AV*)sv, index, 0);
					if(psv != NULL)
					{
						MultiByteToWideChar(CP_ACP, NULL, (char*)SvPV(*psv,na), -1, wzUser, sizeof(wzUser));
						lastError = NetGroupDelUser(lpwServer, lpwGroup, wzUser);
						if(lastError != 0)
							break;
					}
				}
				break;

			default:
				MultiByteToWideChar(CP_ACP, NULL, (char*)SvPV(sv,na), -1, wzUser, sizeof(wzUser));
				lastError = NetGroupDelUser(lpwServer, lpwGroup, wzUser);
				break;
		}
		FreeWideName(lpwServer);
		FreeWideName(lpwGroup);
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_GroupIsMember)
{
	dXSARGS;
	LPWSTR lpwServer, lpwGroup, lpwUser;
	PGROUP_USERS_INFO_0 pwzGroupUsers;
	DWORD entriesRead, totalEntries, resumeHandle = 0;
	int index;
	BOOL bReturn = FALSE;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::GroupIsMember(server, groupName, user)\n");
	}
	{
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwGroup);
		AllocWideName((char*)SvPV(ST(2),na), lpwUser);
		do
		{
			lastError = NetGroupGetUsers(lpwServer, lpwGroup, 0, (LPBYTE*)&pwzGroupUsers,
									PREFLEN, &entriesRead, &totalEntries, &resumeHandle);
			if(lastError != 0)
				break;

			for(index = 0; index < entriesRead; ++index)
				if(lstrcmpiW(lpwUser, pwzGroupUsers[index].grui0_name) == 0)
				{
					bReturn = TRUE;
					break;
				}

			NetApiBufferFree(pwzGroupUsers);
		}
		while((bReturn == FALSE) && (resumeHandle != 0));
		FreeWideName(lpwServer);
		FreeWideName(lpwGroup);
		FreeWideName(lpwUser);
	}
	RETURNRESULT(bReturn);
}

XS(XS_NT__UserAdmin_GroupGetMembers)
{
	dXSARGS;
	LPWSTR lpwServer, lpwGroup;
	char buffer[UNLEN+1];
	PGROUP_USERS_INFO_0 pwzGroupUsers;
	DWORD entriesRead, totalEntries, resumeHandle = 0;
	int index;
	SV *sv, *nSv;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::GroupGetMembers(server, groupName, \\@userArray)\n");
	}
	{
		sv = ST(2);
		if(SvROK(sv))
		{
			sv = SvRV(sv);
		}
		if(SvTYPE(sv) == SVt_PVAV)
		{
			av_clear((AV*)sv);
			AllocWideName((char*)SvPV(ST(0),na), lpwServer);
			AllocWideName((char*)SvPV(ST(1),na), lpwGroup);
			do
			{
				lastError = NetGroupGetUsers(lpwServer, lpwGroup, 0, (LPBYTE*)&pwzGroupUsers,
									PREFLEN, &entriesRead, &totalEntries, &resumeHandle);
				if(lastError != 0)
					break;

				for(index = 0; index < entriesRead; ++index)
				{
					WCTMB(pwzGroupUsers[index].grui0_name, buffer, sizeof(buffer));
					av_push((AV*)sv, newSVpv(buffer, 0));
				}
				NetApiBufferFree(pwzGroupUsers);
			}
			while((entriesRead != 0) && (resumeHandle != 0));
			FreeWideName(lpwServer);
			FreeWideName(lpwGroup);
		}
		else
		{
			croak("Usage: Win32::UserAdmin::GroupGetMember(server, groupName, \\@userArray)\nuserArray was not an array\n");
		}
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_LocalGroupCreate)
{
	dXSARGS;
	LPWSTR lpwServer;
	LOCALGROUP_INFO_1 groupInfo;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::LocalGroupCreate(server, group, comment)\n");
	}
	{
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), groupInfo.lgrpi1_name);
		AllocWideName((char*)SvPV(ST(2),na), groupInfo.lgrpi1_comment);
		lastError = NetLocalGroupAdd(lpwServer, 1, (LPBYTE)&groupInfo, NULL);
		FreeWideName(lpwServer);
		FreeWideName(groupInfo.lgrpi1_name);
		FreeWideName(groupInfo.lgrpi1_comment);
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_LocalGroupDelete)
{
	dXSARGS;
	LPWSTR lpwServer, lpwGroup;

	if (items != 2)
	{
		croak("Usage: Win32::UserAdmin::LocalGroupDelete(server, group)\n");
	}
	{
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwGroup);
		lastError = NetLocalGroupDel(lpwServer, lpwGroup);
		FreeWideName(lpwServer);
		FreeWideName(lpwGroup);
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_LocalGroupGetAttributes)
{
	dXSARGS;
	char buffer[UNLEN+1];
	LPWSTR lpwServer, lpwGroup;
	PLOCALGROUP_INFO_1 pgroupInfo;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::LocalGroupGetAttributes(server, groupName, comment)\n");
	}
	{
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwGroup);
		lastError = NetLocalGroupGetInfo(lpwServer, lpwGroup, 1, (LPBYTE*)&pgroupInfo);
		if(lastError == 0)
		{
			WCTMB(pgroupInfo->lgrpi1_comment, buffer, sizeof(buffer));
			SETPV(2, buffer);
			NetApiBufferFree(pgroupInfo);
		}
		FreeWideName(lpwServer);
		FreeWideName(lpwGroup);
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_LocalGroupSetAttributes)
{
	dXSARGS;
	LPWSTR lpwServer;
	LOCALGROUP_INFO_1 groupInfo;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::LocalGroupSetAttributes(server, groupName, comment)\n");
	}
	{
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), groupInfo.lgrpi1_name);
		AllocWideName((char*)SvPV(ST(2),na), groupInfo.lgrpi1_comment);
		lastError = NetLocalGroupSetInfo(lpwServer, groupInfo.lgrpi1_name, 1, (LPBYTE)&groupInfo, NULL);
		FreeWideName(lpwServer);
		FreeWideName(groupInfo.lgrpi1_name);
		FreeWideName(groupInfo.lgrpi1_comment);
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_LocalGroupAddUsers)
{
	dXSARGS;
	LPWSTR lpwServer, lpwGroup;
	LOCALGROUP_MEMBERS_INFO_3 lgmi3MembersInfo;
	WCHAR wzUser[UNLEN+2];
	int count, index;
	SV *sv, **psv;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::LocalGroupAddUsers(server, groupName, users)\n");
	}
	{
		lgmi3MembersInfo.lgrmi3_domainandname = wzUser;
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwGroup);
		sv = ST(2);
		if(SvROK(sv))
		{
			sv = SvRV(sv);
		}
		switch(SvTYPE(sv))
		{
			case SVt_PVAV:
				count = av_len((AV*)sv);
				for(index = 0; index <= count; ++index)
				{
					psv = av_fetch((AV*)sv, index, 0);
					if(psv != NULL)
					{
						MultiByteToWideChar(CP_ACP, NULL, (char*)SvPV(*psv,na), -1, wzUser, sizeof(wzUser));
						lastError = NetLocalGroupAddMembers(lpwServer, lpwGroup, 3, (LPBYTE)&lgmi3MembersInfo, 1);
						if(lastError != 0)
							break;
					}
				}
				break;

			default:
				MultiByteToWideChar(CP_ACP, NULL, (char*)SvPV(sv,na), -1, wzUser, sizeof(wzUser));
				lastError = NetLocalGroupAddMembers(lpwServer, lpwGroup, 3, (LPBYTE)&lgmi3MembersInfo, 1);
				break;
		}
		FreeWideName(lpwServer);
		FreeWideName(lpwGroup);
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_LocalGroupDeleteUsers)
{
	dXSARGS;
	LPWSTR lpwServer, lpwGroup;
	LOCALGROUP_MEMBERS_INFO_3 lgmi3MembersInfo;
	WCHAR wzUser[UNLEN+2];
	int count, index;
	SV *sv, **psv;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::LocalGroupDelUsers(server, groupName, users)\n");
	}
	{
		lgmi3MembersInfo.lgrmi3_domainandname = wzUser;
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwGroup);
		sv = ST(2);
		if(SvROK(sv))
		{
			sv = SvRV(sv);
		}
		switch(SvTYPE(sv))
		{
			case SVt_PVAV:
				count = av_len((AV*)sv);
				for(index = 0; index <= count; ++index)
				{
					psv = av_fetch((AV*)sv, index, 0);
					if(psv != NULL)
					{
						MultiByteToWideChar(CP_ACP, NULL, (char*)SvPV(*psv,na), -1, wzUser, sizeof(wzUser));
						lastError = NetLocalGroupDelMembers(lpwServer, lpwGroup, 3, (LPBYTE)&lgmi3MembersInfo, 1);
						if(lastError != 0)
							break;
					}
				}
				break;

			default:
				MultiByteToWideChar(CP_ACP, NULL, (char*)SvPV(sv,na), -1, wzUser, sizeof(wzUser));
				lastError = NetLocalGroupDelMembers(lpwServer, lpwGroup, 3, (LPBYTE)&lgmi3MembersInfo, 1);
				break;
		}
		FreeWideName(lpwServer);
		FreeWideName(lpwGroup);
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_LocalGroupIsMember)
{
	dXSARGS;
	LPWSTR lpwServer, lpwGroup, lpwUser;
	PLOCALGROUP_MEMBERS_INFO_1 pwzMembersInfo;
	DWORD entriesRead, totalEntries, resumeHandle = 0;
	int index;
	BOOL bReturn = FALSE;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::LocalGroupIsMember(server, groupName, user)\n");
	}
	{
		AllocWideName((char*)SvPV(ST(0),na), lpwServer);
		AllocWideName((char*)SvPV(ST(1),na), lpwGroup);
		AllocWideName((char*)SvPV(ST(2),na), lpwUser);
		do
		{
			lastError = NetLocalGroupGetMembers(lpwServer, lpwGroup, 1, (LPBYTE*)&pwzMembersInfo,
									PREFLEN, &entriesRead, &totalEntries, &resumeHandle);
			if(lastError != 0)
				break;

			for(index = 0; index < entriesRead; ++index)
				if(lstrcmpiW(lpwUser, pwzMembersInfo[index].lgrmi1_name) == 0)
				{
					bReturn = TRUE;
					break;
				}

			NetApiBufferFree(pwzMembersInfo);
		}
		while((bReturn == FALSE) && (resumeHandle != 0));
		FreeWideName(lpwServer);
		FreeWideName(lpwGroup);
		FreeWideName(lpwUser);
	}
	RETURNRESULT(bReturn);
}

XS(XS_NT__UserAdmin_LocalGroupGetMembers)
{
	dXSARGS;
	LPWSTR lpwServer, lpwGroup;
	char buffer[UNLEN+1];
	PLOCALGROUP_MEMBERS_INFO_1 pwzMembersInfo;
	DWORD entriesRead, totalEntries, resumeHandle = 0;
	int index;
	SV *sv, *nSv;

	if (items != 3)
	{
		croak("Usage: Win32::UserAdmin::LocalGroupGetMembers(server, groupName, \\@userArray)\n");
	}
	{
		sv = ST(2);
		if(SvROK(sv))
		{
			sv = SvRV(sv);
		}
		if(SvTYPE(sv) == SVt_PVAV)
		{
			av_clear((AV*)sv);
			AllocWideName((char*)SvPV(ST(0),na), lpwServer);
			AllocWideName((char*)SvPV(ST(1),na), lpwGroup);
			do
			{
				lastError = NetLocalGroupGetMembers(lpwServer, lpwGroup, 1, (LPBYTE*)&pwzMembersInfo,
										PREFLEN, &entriesRead, &totalEntries, &resumeHandle);
				if(lastError != 0)
					break;

				for(index = 0; index < entriesRead; ++index)
				{
					WCTMB(pwzMembersInfo[index].lgrmi1_name, buffer, sizeof(buffer));
					av_push((AV*)sv, newSVpv(buffer, 0));
				}
				NetApiBufferFree(pwzMembersInfo);
			}
			while((entriesRead != 0) && (resumeHandle != 0));
			FreeWideName(lpwServer);
			FreeWideName(lpwGroup);
		}
		else
		{
			croak("Usage: Win32::UserAdmin::LocalGroupGetMember(server, groupName, \\@userArray)\nuserArray was not an array\n");
		}
	}
	RETURNRESULT(lastError == 0);
}

XS(XS_NT__UserAdmin_GetServers)
{
	dXSARGS;
	LPWSTR lpwServer, lpwDomain;
	char buffer[UNLEN+1];
	PSERVER_INFO_100 pwzServerInfo;
	DWORD entriesRead, totalEntries, resumeHandle = 0;
	int index;
	SV *sv, *nSv;

	if (items != 4)
	{
		croak("Usage: Win32::UserAdmin::GetServers(server, domain, flags, \\@serverArray)\n");
	}
	{
		sv = ST(3);
		if(SvROK(sv))
		{
			sv = SvRV(sv);
		}
		if(SvTYPE(sv) == SVt_PVAV)
		{
			av_clear((AV*)sv);
			AllocWideName((char*)SvPV(ST(0),na), lpwServer);
			AllocWideName((char*)SvPV(ST(1),na), lpwDomain);
			do
			{
				lastError = NetServerEnum(lpwServer, 100, (LPBYTE*) &pwzServerInfo,
								PREFLEN, &entriesRead, &totalEntries, (DWORD)SvIV(ST(2)), lpwDomain, &resumeHandle);
				if(lastError != 0)
					break;

				for(index = 0; index < entriesRead; ++index)
				{
					WCTMB(pwzServerInfo[index].sv100_name, buffer, sizeof(buffer));
					av_push((AV*)sv, newSVpv(buffer, 0));
				}
				NetApiBufferFree(pwzServerInfo);
			}
			while((entriesRead != 0) && (resumeHandle != 0));
			FreeWideName(lpwServer);
			FreeWideName(lpwDomain);
		}
		else
		{
			croak("Usage: Win32::UserAdmin::GetServers(server, domain, flags, \\@serverArray)\nserverArray was not an array\n");
		}
	}
	RETURNRESULT(lastError == 0);
}

XS(boot_Win32__UserAdmin)
{
	dXSARGS;
	char* file = __FILE__;

	newXS("Win32::UserAdmin::constant", XS_NT__UserAdmin_constant, file);
	newXS("Win32::UserAdmin::GetError", XS_NT__UserAdmin_GetError, file);
	newXS("Win32::UserAdmin::GetDomainController", XS_NT__UserAdmin_GetDomainController, file);
	newXS("Win32::UserAdmin::UserCreate", XS_NT__UserAdmin_UserCreate, file);
	newXS("Win32::UserAdmin::UserDelete", XS_NT__UserAdmin_UserDelete, file);
	newXS("Win32::UserAdmin::UserGetAttributes", XS_NT__UserAdmin_UserGetAttributes, file);
	newXS("Win32::UserAdmin::UserSetAttributes", XS_NT__UserAdmin_UserSetAttributes, file);
	newXS("Win32::UserAdmin::NetShareGetInfo", XS_NT__UserAdmin_NetShareGetInfo, file);
	newXS("Win32::UserAdmin::NetShareSetInfo", XS_NT__UserAdmin_NetShareSetInfo, file);
	newXS("Win32::UserAdmin::NetShareAdd", XS_NT__UserAdmin_NetShareAdd, file);
	newXS("Win32::UserAdmin::NetShareDel", XS_NT__UserAdmin_NetShareDel, file);
	newXS("Win32::UserAdmin::UserChangePassword", XS_NT__UserAdmin_UserChangePassword, file);
	newXS("Win32::UserAdmin::UserGetGroups", XS_NT__UserAdmin_UserGetGroups, file);
	newXS("Win32::UserAdmin::UserGetLocalGroups", XS_NT__UserAdmin_UserGetLocalGroups, file);
	newXS("Win32::UserAdmin::UsersExist", XS_NT__UserAdmin_UsersExist, file);
	newXS("Win32::UserAdmin::GetUsers", XS_NT__UserAdmin_GetUsers, file);
	newXS("Win32::UserAdmin::GetGroups", XS_NT__UserAdmin_GetGroups, file);
	newXS("Win32::UserAdmin::GroupCreate", XS_NT__UserAdmin_GroupCreate, file);
	newXS("Win32::UserAdmin::GroupDelete", XS_NT__UserAdmin_GroupDelete, file);
	newXS("Win32::UserAdmin::GroupGetAttributes", XS_NT__UserAdmin_GroupGetAttributes, file);
	newXS("Win32::UserAdmin::GroupSetAttributes", XS_NT__UserAdmin_GroupSetAttributes, file);
	newXS("Win32::UserAdmin::GroupAddUsers", XS_NT__UserAdmin_GroupAddUsers, file);
	newXS("Win32::UserAdmin::GroupDeleteUsers", XS_NT__UserAdmin_GroupDeleteUsers, file);
	newXS("Win32::UserAdmin::GroupIsMember", XS_NT__UserAdmin_GroupIsMember, file);
	newXS("Win32::UserAdmin::GroupGetMembers", XS_NT__UserAdmin_GroupGetMembers, file);
	newXS("Win32::UserAdmin::LocalGroupCreate", XS_NT__UserAdmin_LocalGroupCreate, file);
	newXS("Win32::UserAdmin::LocalGroupDelete", XS_NT__UserAdmin_LocalGroupDelete, file);
	newXS("Win32::UserAdmin::LocalGroupGetAttributes", XS_NT__UserAdmin_LocalGroupGetAttributes, file);
	newXS("Win32::UserAdmin::LocalGroupSetAttributes", XS_NT__UserAdmin_LocalGroupSetAttributes, file);
	newXS("Win32::UserAdmin::LocalGroupAddUsers", XS_NT__UserAdmin_LocalGroupAddUsers, file);
	newXS("Win32::UserAdmin::LocalGroupDeleteUsers", XS_NT__UserAdmin_LocalGroupDeleteUsers, file);
	newXS("Win32::UserAdmin::LocalGroupIsMember", XS_NT__UserAdmin_LocalGroupIsMember, file);
	newXS("Win32::UserAdmin::LocalGroupGetMembers", XS_NT__UserAdmin_LocalGroupGetMembers, file);
	newXS("Win32::UserAdmin::GetServers", XS_NT__UserAdmin_GetServers, file);
	ST(0) = &sv_yes;
	XSRETURN(1);
}

